//+------------------------------------------------------------------+
//|                                                  Custom MACD.mq4 |
//|                      Copyright  2004, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
//2008fxtsd
#property  copyright "Copyright  2004, MetaQuotes Software Corp."
#property  link      "http://www.metaquotes.net/"
//---- indicator settings
#property  indicator_chart_window
#property  indicator_buffers 2
#property  indicator_color1  RoyalBlue
#property  indicator_color2  Red
#property indicator_width1 1
#property indicator_width2 1

//---- indicator parameters
extern int FastMA_Period=12;
extern int SlowMA_Period=26;
extern int SignalMA_Period=9;

extern int FastMA_Mode=1;
extern int SlowMA_Mode=1;
extern int SignalMA_Mode=0;

extern int FastMA_Price=0;
extern int SlowMA_Price=0;

extern double    PSARStep=0.02;
extern double    PSARMaximum=0.2;


extern double SigDistance =1.5;

//---- indicator buffers
double     TriggerUP[];
double     TriggerDN[],MACD[],Signal[],SAR[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- drawing settings
   
   IndicatorBuffers (5);
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,SYMBOL_ARROWUP);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,SYMBOL_ARROWDOWN);
   
   SetIndexEmptyValue(0,EMPTY_VALUE);
   SetIndexEmptyValue(1,EMPTY_VALUE);
   
   SetIndexBuffer(0,TriggerUP);
   SetIndexBuffer(1,TriggerDN);


   SetIndexBuffer(2,MACD);
   SetIndexBuffer(3,Signal);
   SetIndexBuffer(4,SAR);

 
 
      
   return(0);
  }
//+------------------------------------------------------------------+
//| Moving Averages Convergence/Divergence                           |
//+------------------------------------------------------------------+
int start()
  {
   int i,limit,MACDTrigger,SARTrigger,counted_bars=IndicatorCounted();
   double MACDHistCur,MACDHistPrev;
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;

   for (i=limit; i>=0; i--)
      
     MACD [i] =iMA(NULL,0,FastMA_Period,0,FastMA_Mode,FastMA_Price,i)-
               iMA(NULL,0,SlowMA_Period,0,SlowMA_Mode,SlowMA_Price,i);
   
   for (i=limit; i>=0; i--)
      {
     Signal[i]=iMAOnArray(MACD,0,SignalMA_Period,0,SignalMA_Mode,i);
     }
        for (i=limit; i>=0; i--)
      {

     SAR[i]=iSAR(NULL,0,PSARStep,PSARMaximum,i);

    double SignalGap = MathCeil(iATR(NULL,0,10,0)/Point)*SigDistance;

     if (SAR [i]<Close[i] && MACD[i+1]<=Signal[i+1] && MACD[i]>Signal[i])

         TriggerUP[i]=Low[i]-SignalGap*Point; 

     if (SAR [i]>Close[i] && MACD[i+1]>=Signal[i+1] && MACD[i]<Signal[i])

          TriggerDN[i]=High[i]+SignalGap*Point;

         } 
        
     
   return(0);
  }
//+------------------------------------------------------------------+

