//+------------------------------------------------------------------+
//|                                                     Rezsup++.mq4 |
//|                                                            Deevz |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Deevz"
#property link      "http://www.metaquotes.net"

#property indicator_chart_window
#property indicator_color1 Crimson
//---- input parameters
extern int       ExtCandleCount=500;
extern int ExtRange=5;
extern int ExtMinContact=0;

double Buffer1[];
double Extremum[99];
double ProcessedEx[99];
double Density[99];
int ObjNb;
datetime Cur_Time;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  SetIndexBuffer(0, Buffer1);
  SetIndexStyle(0, DRAW_LINE);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
   while (ObjNb>0)
   {
      int handle=ObjectDelete(DoubleToStr(ObjNb,0));
      int err;
      if(handle<1)
      {
         err=GetLastError();
         Print("error(",err,")");
      }

      ObjNb--;
   }
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   if (Cur_Time==Time[0]) {return(0);} //Compares the start time of the last calculated candle to that of the current one.
   if (Cur_Time!=Time[0]) {Cur_Time=Time[0]; Print("Calculating R&S for a new candle...");}
   while (ObjNb>0)
   {
      int handle=ObjectDelete(DoubleToStr(ObjNb,0));
      int err;
      if(handle<1)
      {
         err=GetLastError();
         Print("error(",err,")");
      }

      ObjNb--;
   }
   int count=0;
   int count1=0;
   ArrayResize(Extremum, 99);
   ArrayResize(ProcessedEx, 99);
   ArrayResize(Density, 99);
   for (int shift=0; shift<ExtCandleCount; shift++)
   {
      double Zig = iCustom(Symbol(),Period(),"ZigZag",5,5,3,0,shift);
      if (Zig!=0)
      {        
         
         Extremum[count]=Zig;
         Extremum[1]=Zig;
         count++;
      }
   }
   ArrayResize(Extremum, count);
   Print(ArraySize(Extremum));
   ArraySort(Extremum, WHOLE_ARRAY, 0, MODE_ASCEND); //Sorts the array, with the higher index holding the higher price.
   for (int shift1=0; shift1<count; shift1++)
   {
      if (Extremum[shift1]==Extremum[shift1-1]) {continue;}
      double URange=Extremum[shift1]+ExtRange*Point;
      double DRange=Extremum[shift1]-ExtRange*Point;
      int dens=0;
      for (int shift2=0; shift2<count; shift2++)
      {
         if (Extremum[shift2]<=URange && Extremum[shift2]>=DRange) {dens++;}
      }
      ProcessedEx[count1]=Extremum[shift1];
      Density[count1]=dens;
      count1++;
   }
   ArrayResize(ProcessedEx, count1);
   ArrayResize(Density, count1);
   string list;
   for (int i=0;i<count1;i++)
   {      
      if (Density[i+1]<Density[i])
      {
      ObjNb++;
      ObjectCreate(DoubleToStr(ObjNb,0), OBJ_HLINE, 0, 0, ProcessedEx[i]);
      }
      list = list+DoubleToStr(Density[i],0)+"("+DoubleToStr(ProcessedEx[i],Digits)+")"+", ";
   }
   Print(list);
   return(0);
}
//+------------------------------------------------------------------+