//+------------------------------------------------------------------+
//|                                                        Ticks.mq4 |
//|                                                       MetaQuotes |
//|                    http://www.alpari-idc.ru/ru/experts/articles/ |
//+------------------------------------------------------------------+
//| _TRO_MODIFIED_VERSION                                  |
//| MODIFIED BY AVERY T. HORTON, JR. AKA THERUMPLEDONE@GMAIL.COM     |
//| I am NOT the ORIGINAL author 
//  and I am not claiming authorship of this indicator. 
//  All I did was modify it. I hope you find my modifications useful.|
//|                                                                  |
//+------------------------------------------------------------------+

#property copyright "Rosh"
#property link      "http://www.alpari-idc.ru/ru/experts/articles/"
 
#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 Orange
//---- buffers
extern int MaxDrawTicks=500;
double ExtMapBuffer1[];
int myBars;
int tickCounter;
int delimeterCounter;



//+------------------------------------------------------------------+


int      window;  
int      corner;
int      totalLabels;

color  ColorLabels  = Gray;

color  color5 = Red;
color  color4 = Orange;
color  color3 = Yellow;
color  color2 = Green;
color  color1 = Lime;
color  coltrend;

string   labelNames;
string   shortName;



//+------------------------------------------------------------------+
int init()
  {
 
    shortName="Tick by Tick";
   IndicatorShortName(shortName);   
  
  
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0, ExtMapBuffer1);
   SetIndexEmptyValue(0,0.0);
//   Print("???????? ????");
   for (int i=Bars-1;i>=0;i--) ExtMapBuffer1[i]=0.0;
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
    ObjectsDeleteAll(window);  
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| ??????? ??????                                                   |
//+------------------------------------------------------------------+
void SetDelimeter()
  {
//----
   string delimeterDate=TimeToStr(Time[0]);
   if (myBars!=0)
      {
      //Print("?????? ???????????");    
        
//      int handle=WindowFind("Ticks");
      
        int handle=WindowFind(shortName);                  
      
      if(!ObjectCreate(delimeterDate,OBJ_VLINE,handle,Time[0],0))
         {
        // Alert("???????? ??????? ???????? ??????????? ? ???? ",
        // handle," ?? ??????? ",TimeToStr(CurTime()));
         Print("?????? ?",GetLastError(),", ??? ??????????? ",delimeterDate);
         }
      else 
         {
         ObjectSet(delimeterDate,OBJPROP_COLOR,DarkGreen);
         ObjectSet(delimeterDate,OBJPROP_STYLE,STYLE_DASHDOT);
         ObjectsRedraw();
         }
      }
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| ??????? ??????                                                   |
//+------------------------------------------------------------------+
void ShiftArray()
  {
//----
   int V_lines;
   string delimeterName;
   datetime firstTime;
   int BarFirstTime;
   
   if (tickCounter>2*MaxDrawTicks)
      {
      for (int i=tickCounter;i>=MaxDrawTicks;i--) ExtMapBuffer1[i]=0.0;
      tickCounter=MaxDrawTicks;
      }
   for(int cnt=tickCounter;cnt>0;cnt--)
      {
      ExtMapBuffer1[cnt]=ExtMapBuffer1[cnt-1];
      }
   V_lines=ObjectsTotal();
   for (int z=0;z<V_lines;z++)
      {
      delimeterName=ObjectName(z); 
      if (ObjectFind(delimeterName)!=-1)
         {
         if (ObjectType(delimeterName)==OBJ_VLINE) 
            {
            firstTime=ObjectGet(delimeterName,OBJPROP_TIME1);
            BarFirstTime=iBarShift(NULL,0,firstTime);
            firstTime=Time[BarFirstTime+1];
            ObjectSet(delimeterName,OBJPROP_TIME1,firstTime); 
            }
         }       
      }
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| ??????? ?????? ????                                              |
//+------------------------------------------------------------------+
bool isNewBar()
  {
//----
   bool res=false;
   if (myBars!=Bars)
      {
      res=true;
      myBars=Bars;
      }   
//----
   return(res);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
  
     window = WindowFind(shortName);      
     
   int    counted_bars=IndicatorCounted();
//----
   if (isNewBar())
      {
      // ?????????? ???????????
      tickCounter++;
      SetDelimeter();
      ExtMapBuffer1[0]=Bid;      
      }
   else
      
      {
      tickCounter++;
      ShiftArray();
      ExtMapBuffer1[0]=Bid;      
      }      
//----
   DoShowLegend() ;

   return(0);
  }
//+------------------------------------------------------------------+


//+------------------------------------------------------------------+



void DoShowLegend()
{

int       X_trend               =  0; // 360;
int       Y_trend               =  0; // 20;

   corner = 1;
   string sClose = DoubleToStr(iClose(NULL,0,0),Digits) ;
   string symbol = Symbol() ;
   string tHead  = symbol + " " + sClose  ;   
   
   string tik_Val = DoubleToStr(ExtMapBuffer1[0],Digits) ;
   
   

      if(ExtMapBuffer1[0]  > ExtMapBuffer1[1] ) { coltrend = Lime ;  } else { coltrend = Red ;  }  
 

     
   setObject("tik_current", tHead ,30,08, coltrend ,"Arial Bold" );
/*    
   ObjectCreate("tik_value", OBJ_LABEL, window, 0, 0);
   ObjectSetText("tik_value",tik_Val,30, "Arial Bold", coltrend );   // coltrend Trend_UP
   ObjectSet("tik_value", OBJPROP_CORNER, corner);
   ObjectSet("tik_value", OBJPROP_XDISTANCE, 1000+X_trend-900); // 955+X_trend-900
   ObjectSet("tik_value", OBJPROP_YDISTANCE, 26+Y_trend);    
*/    
}

//+------------------------------------------------------------------+

string next() { totalLabels++; return(totalLabels); }  
//+------------------------------------------------------------------+
void setObject(string name,string text,int x,int y,color theColor, string font = "Arial",int size=10,int angle=0)
{
   string labelName = StringConcatenate(labelNames,name);

      
      if (ObjectFind(labelName) == -1)
          {
             ObjectCreate(labelName,OBJ_LABEL,window,0,0);
             ObjectSet(labelName,OBJPROP_CORNER,corner);
             if (angle != 0)
                  ObjectSet(labelName,OBJPROP_ANGLE,angle);
          }               
       ObjectSet(labelName,OBJPROP_XDISTANCE,x);
       ObjectSet(labelName,OBJPROP_YDISTANCE,y);
       ObjectSetText(labelName,text,size,font,theColor);
}

//+------------------------------------------------------------------+

string MakeUniqueName(string first, string rest)
{
   string result = first+(MathRand()%1001)+rest;

   while (WindowFind(result)> 0)
          result = first+(MathRand()%1001)+rest;
   return(result);
}

//+------------------------------------------------------------------+  
 